package protocolP2P;
import protocolP2P.RequestResponseCode;
import protocolP2P.FilePart;
import protocolP2P.FileList;
import exception.ProtocolError;

public class Payload {
	private RequestResponseCode requestResponseCode;
	protected final static int PAYLOAD_SIZE_POSITON = 4;
	protected final static int PAYLOAD_START_POSITION = 8;

	/** To create request/response with a payload size of zero */
	public Payload(RequestResponseCode requestResponseCode) {
		assert requestResponseCode != requestResponseCode.LIST_RESPONSE : "LIST_RESPONSE must use FilePart class";
		assert requestResponseCode != requestResponseCode.LOAD_RESPONSE : "LOAD_RESPONSE must use FileList class";
		this.requestResponseCode = requestResponseCode;
	}

	public Payload(byte[] datagram) throws ProtocolError {
		assert RequestResponseCode.fromCode(datagram[RequestResponseCode.RRCODE_POSITION]) != RequestResponseCode.LIST_RESPONSE : "LIST_RESPONSE must use FilePart class";
		assert RequestResponseCode.fromCode(datagram[RequestResponseCode.RRCODE_POSITION]) != RequestResponseCode.LOAD_RESPONSE : "LOAD_RESPONSE must use FileList class";
		requestResponseCode = RequestResponseCode.fromCode(datagram[RequestResponseCode.RRCODE_POSITION]);
	}
	
	/** Payload with padding */
	public byte[] toDatagram() {
		byte [] datagram = new byte[8]; // java initialize all to zero
		// size is keep blank (ProtocolP2PDatagram will handle it)
		// set request/response code
		datagram[RequestResponseCode.RRCODE_POSITION] = requestResponseCode.codeValue;
		// bits 16-31 are reserved for future use
		// payload size is 0 (this is what java have initialized datagram)
	}
}
